/* Utils.c generated by valac 0.40.6, the Vala compiler
 * generated from Utils.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <meta/window.h>
#include <libbamf/libbamf.h>
#include <gio/gdesktopappinfo.h>
#include <plank.h>
#include <gio/gio.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <meta/workspace.h>
#include <meta/screen.h>
#include <meta/display.h>
#include <meta/meta-window-actor.h>
#include <meta/boxes.h>
#include <clutter/clutter.h>
#include <meta/meta-shaped-texture.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>
#include <meta/compositor.h>
#include <meta/meta-backend.h>
#include <meta/main.h>
#include <meta/meta-settings.h>
#include <config.h>
#include <gobject/gvaluecollector.h>


#define GALA_TYPE_UTILS (gala_utils_get_type ())
#define GALA_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_UTILS, GalaUtils))
#define GALA_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_UTILS, GalaUtilsClass))
#define GALA_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_UTILS))
#define GALA_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_UTILS))
#define GALA_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_UTILS, GalaUtilsClass))

typedef struct _GalaUtils GalaUtils;
typedef struct _GalaUtilsClass GalaUtilsClass;
typedef struct _GalaUtilsPrivate GalaUtilsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _GalaParamSpecUtils GalaParamSpecUtils;

struct _GalaUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaUtilsPrivate * priv;
};

struct _GalaUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (GalaUtils *self);
};

struct _Block1Data {
	int _ref_count_;
	guint32* xids;
	gint xids_length1;
};

struct _Block2Data {
	int _ref_count_;
	cairo_surface_t* surface;
};

struct _GalaParamSpecUtils {
	GParamSpec parent_instance;
};


static gpointer gala_utils_parent_class = NULL;
static GHashTable* gala_utils_xid_pixbuf_cache;
static GHashTable* gala_utils_xid_pixbuf_cache = NULL;
static GHashTable* gala_utils_icon_pixbuf_cache;
static GHashTable* gala_utils_icon_pixbuf_cache = NULL;
static guint gala_utils_cache_clear_timeout;
static guint gala_utils_cache_clear_timeout = (guint) 0;
static GdkPixbuf* gala_utils_close_pixbuf;
static GdkPixbuf* gala_utils_close_pixbuf = NULL;
static GdkPixbuf* gala_utils_resize_pixbuf;
static GdkPixbuf* gala_utils_resize_pixbuf = NULL;

gpointer gala_utils_ref (gpointer instance);
void gala_utils_unref (gpointer instance);
GParamSpec* gala_param_spec_utils (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void gala_value_set_utils (GValue* value,
                           gpointer v_object);
void gala_value_take_utils (GValue* value,
                            gpointer v_object);
gpointer gala_value_get_utils (const GValue* value);
GType gala_utils_get_type (void) G_GNUC_CONST;
static GalaUtils* gala_utils_new (void);
static GalaUtils* gala_utils_construct (GType object_type);
static void gala_utils_clean_icon_cache (guint32* xids,
                                  int xids_length1);
static gboolean _vala_uint32_array_contains (guint32 * stack,
                                      int stack_length,
                                      guint32 needle);
void gala_utils_request_clean_icon_cache (guint32* xids,
                                          int xids_length1);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block1Data* _data1_);
static gboolean __lambda6_ (Block1Data* _data1_);
static gboolean ___lambda6__gsource_func (gpointer self);
static gboolean ___lambda5__gsource_func (gpointer self);
GdkPixbuf* gala_utils_get_icon_for_window (MetaWindow* window,
                                           gint size,
                                           gint scale,
                                           gboolean ignore_cache);
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid,
                                        gint size,
                                        gint scale,
                                        gboolean ignore_cache);
static GdkPixbuf* gala_utils_get_icon_for_application (BamfApplication* app,
                                                gint size,
                                                gint scale,
                                                gboolean ignore_cache);
MetaWindow* gala_utils_get_next_window (MetaWorkspace* workspace,
                                        gboolean backward);
guint gala_utils_get_n_windows (MetaWorkspace* workspace);
ClutterActor* gala_utils_get_window_actor_snapshot (MetaWindowActor* actor,
                                                    MetaRectangle* inner_rect,
                                                    MetaRectangle* outer_rect);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block2Data* _data2_,
                     cairo_t* cr);
static gboolean ___lambda7__clutter_canvas_draw (ClutterCanvas* _sender,
                                          cairo_t* cr,
                                          gint width,
                                          gint height,
                                          gpointer self);
void gala_utils_bell (MetaScreen* screen);
GdkPixbuf* gala_utils_get_close_button_pixbuf (void);
ClutterActor* gala_utils_create_close_button (void);
GdkPixbuf* gala_utils_get_resize_button_pixbuf (void);
ClutterActor* gala_utils_create_resize_button (void);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void gala_utils_finalize (GalaUtils * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static GalaUtils*
gala_utils_construct (GType object_type)
{
	GalaUtils* self = NULL;
	self = (GalaUtils*) g_type_create_instance (object_type);
	return self;
}


static GalaUtils*
gala_utils_new (void)
{
	return gala_utils_construct (GALA_TYPE_UTILS);
}


/**
 * Clean icon caches
 */
static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
	guint64 _tmp0_;
	g_return_val_if_fail (str != NULL, 0ULL);
	_tmp0_ = g_ascii_strtoull (str, NULL, (guint) 0);
	result = _tmp0_;
	return result;
}


static gboolean
_vala_uint32_array_contains (guint32 * stack,
                             int stack_length,
                             guint32 needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
gala_utils_clean_icon_cache (guint32* xids,
                             int xids_length1)
{
	GList* list = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GList* pixbuf_list = NULL;
	GHashTable* _tmp2_;
	GList* _tmp3_;
	GList* icon_list = NULL;
	GHashTable* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	_tmp0_ = gala_utils_xid_pixbuf_cache;
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
	list = _tmp1_;
	_tmp2_ = gala_utils_icon_pixbuf_cache;
	_tmp3_ = g_hash_table_get_values (_tmp2_);
	pixbuf_list = _tmp3_;
	_tmp4_ = gala_utils_icon_pixbuf_cache;
	_tmp5_ = g_hash_table_get_keys (_tmp4_);
	icon_list = _tmp5_;
	_tmp6_ = list;
	{
		GList* xid_key_collection = NULL;
		GList* xid_key_it = NULL;
		xid_key_collection = _tmp6_;
		for (xid_key_it = xid_key_collection; xid_key_it != NULL; xid_key_it = xid_key_it->next) {
			const gchar* xid_key = NULL;
			xid_key = (const gchar*) xid_key_it->data;
			{
				guint32 xid = 0U;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				guint32 _tmp12_;
				guint32 _tmp13_;
				_tmp7_ = xid_key;
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "::", 0);
				_tmp10_ = _tmp9_;
				_tmp10__length1 = _vala_array_length (_tmp8_);
				_tmp11_ = _tmp10_[0];
				_tmp12_ = (guint32) uint64_parse (_tmp11_);
				_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
				xid = _tmp12_;
				_tmp13_ = xid;
				if (!_vala_uint32_array_contains (xids, xids_length1, _tmp13_)) {
					GdkPixbuf* pixbuf = NULL;
					GHashTable* _tmp14_;
					const gchar* _tmp15_;
					gconstpointer _tmp16_;
					GdkPixbuf* _tmp17_;
					GHashTable* _tmp30_;
					const gchar* _tmp31_;
					_tmp14_ = gala_utils_xid_pixbuf_cache;
					_tmp15_ = xid_key;
					_tmp16_ = g_hash_table_lookup (_tmp14_, _tmp15_);
					_tmp17_ = _g_object_ref0 ((GdkPixbuf*) _tmp16_);
					pixbuf = _tmp17_;
					{
						gint j = 0;
						j = 0;
						{
							gboolean _tmp18_ = FALSE;
							_tmp18_ = TRUE;
							while (TRUE) {
								gint _tmp20_;
								GList* _tmp21_;
								GList* _tmp22_;
								gint _tmp23_;
								gconstpointer _tmp24_;
								GdkPixbuf* _tmp25_;
								if (!_tmp18_) {
									gint _tmp19_;
									_tmp19_ = j;
									j = _tmp19_ + 1;
								}
								_tmp18_ = FALSE;
								_tmp20_ = j;
								_tmp21_ = pixbuf_list;
								if (!(((guint) _tmp20_) < g_list_length (_tmp21_))) {
									break;
								}
								_tmp22_ = pixbuf_list;
								_tmp23_ = j;
								_tmp24_ = g_list_nth_data (_tmp22_, (guint) _tmp23_);
								_tmp25_ = pixbuf;
								if (((GdkPixbuf*) _tmp24_) == _tmp25_) {
									GHashTable* _tmp26_;
									GList* _tmp27_;
									gint _tmp28_;
									gconstpointer _tmp29_;
									_tmp26_ = gala_utils_xid_pixbuf_cache;
									_tmp27_ = icon_list;
									_tmp28_ = j;
									_tmp29_ = g_list_nth_data (_tmp27_, (guint) _tmp28_);
									g_hash_table_remove (_tmp26_, (const gchar*) _tmp29_);
								}
							}
						}
					}
					_tmp30_ = gala_utils_xid_pixbuf_cache;
					_tmp31_ = xid_key;
					g_hash_table_remove (_tmp30_, _tmp31_);
					_g_object_unref0 (pixbuf);
				}
			}
		}
	}
	_g_list_free0 (icon_list);
	_g_list_free0 (pixbuf_list);
	_g_list_free0 (list);
}


/**
 * Marks the given xids as no longer needed, the corresponding icons
 * may be freed now. Mainly for internal purposes.
 *
 * @param xids The xids of the window that no longer need icons
 */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean
__lambda6_ (Block1Data* _data1_)
{
	gboolean result = FALSE;
	gala_utils_clean_icon_cache (_data1_->xids, _data1_->xids_length1);
	result = FALSE;
	return result;
}


static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
	return result;
}


static gboolean
__lambda5_ (Block1Data* _data1_)
{
	gboolean result = FALSE;
	gala_utils_cache_clear_timeout = (guint) 0;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda6__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	result = FALSE;
	return result;
}


static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
	return result;
}


void
gala_utils_request_clean_icon_cache (guint32* xids,
                                     int xids_length1)
{
	Block1Data* _data1_;
	guint _tmp0_;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->xids = xids;
	_data1_->xids_length1 = xids_length1;
	_tmp0_ = gala_utils_cache_clear_timeout;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = gala_utils_cache_clear_timeout;
		g_source_remove (_tmp1_);
	}
	gala_utils_cache_clear_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 30, ___lambda5__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


/**
 * Returns a pixbuf for the application of this window or a default icon
 *
 * @param window       The window to get an icon for
 * @param size         The size of the icon
 * @param scale        The desired scale of the icon
 * @param ignore_cache Should not be necessary in most cases, if you care about the icon
 *                     being loaded correctly, you should consider using the WindowIcon class
 */
GdkPixbuf*
gala_utils_get_icon_for_window (MetaWindow* window,
                                gint size,
                                gint scale,
                                gboolean ignore_cache)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = gala_utils_get_icon_for_xid ((guint32) meta_window_get_xwindow (window), size, scale, ignore_cache);
	result = _tmp0_;
	return result;
}


/**
 * Returns a pixbuf for a given xid or a default icon
 *
 * @see get_icon_for_window
 */
GdkPixbuf*
gala_utils_get_icon_for_xid (guint32 xid,
                             gint size,
                             gint scale,
                             gboolean ignore_cache)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _result_ = NULL;
	gchar* xid_key = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp7_;
	BamfMatcher* _tmp8_;
	BamfApplication* _tmp9_;
	BamfApplication* _tmp10_;
	BamfApplication* _tmp11_;
	BamfApplication* _tmp12_;
	GdkPixbuf* _tmp13_;
	GHashTable* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* _tmp18_;
	_result_ = NULL;
	_tmp0_ = g_strdup_printf ("%u::%i", (guint) xid, size);
	xid_key = _tmp0_;
	if (!ignore_cache) {
		GHashTable* _tmp2_;
		const gchar* _tmp3_;
		gconstpointer _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
		_tmp2_ = gala_utils_xid_pixbuf_cache;
		_tmp3_ = xid_key;
		_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
		_tmp5_ = _g_object_ref0 ((GdkPixbuf*) _tmp4_);
		_g_object_unref0 (_result_);
		_result_ = _tmp5_;
		_tmp6_ = _result_;
		_tmp1_ = _tmp6_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		result = _result_;
		_g_free0 (xid_key);
		return result;
	}
	_tmp7_ = bamf_matcher_get_default ();
	_tmp8_ = _tmp7_;
	_tmp9_ = bamf_matcher_get_application_for_xid (_tmp8_, xid);
	_tmp10_ = _g_object_ref0 (_tmp9_);
	_tmp11_ = _tmp10_;
	_g_object_unref0 (_tmp8_);
	app = _tmp11_;
	_tmp12_ = app;
	_tmp13_ = gala_utils_get_icon_for_application (_tmp12_, size, scale, ignore_cache);
	_g_object_unref0 (_result_);
	_result_ = _tmp13_;
	_tmp14_ = gala_utils_xid_pixbuf_cache;
	_tmp15_ = xid_key;
	_tmp16_ = g_strdup (_tmp15_);
	_tmp17_ = _result_;
	_tmp18_ = _g_object_ref0 (_tmp17_);
	g_hash_table_insert (_tmp14_, _tmp16_, _tmp18_);
	result = _result_;
	_g_object_unref0 (app);
	_g_free0 (xid_key);
	return result;
}


/**
 * Returns a pixbuf for this application or a default icon
 *
 * @see get_icon_for_window
 */
static GdkPixbuf*
gala_utils_get_icon_for_application (BamfApplication* app,
                                     gint size,
                                     gint scale,
                                     gboolean ignore_cache)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* image = NULL;
	gboolean not_cached = FALSE;
	gchar* icon = NULL;
	gchar* icon_key = NULL;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* _tmp41_;
	gboolean _tmp51_ = FALSE;
	GdkPixbuf* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	gboolean _tmp60_;
	GError * _inner_error_ = NULL;
	image = NULL;
	not_cached = FALSE;
	icon = NULL;
	icon_key = NULL;
	if (app != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = bamf_application_get_desktop_file (app);
		_tmp0_ = _tmp1_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GDesktopAppInfo* appinfo = NULL;
		const gchar* _tmp2_;
		GDesktopAppInfo* _tmp3_;
		GDesktopAppInfo* _tmp4_;
		_tmp2_ = bamf_application_get_desktop_file (app);
		_tmp3_ = g_desktop_app_info_new_from_filename (_tmp2_);
		appinfo = _tmp3_;
		_tmp4_ = appinfo;
		if (_tmp4_ != NULL) {
			GDesktopAppInfo* _tmp5_;
			GIcon* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gboolean _tmp10_ = FALSE;
			_tmp5_ = appinfo;
			_tmp6_ = g_app_info_get_icon ((GAppInfo*) _tmp5_);
			_tmp7_ = plank_drawing_service_get_icon_from_gicon (_tmp6_);
			_g_free0 (icon);
			icon = _tmp7_;
			_tmp8_ = icon;
			_tmp9_ = g_strdup_printf ("%s::%i::%i", _tmp8_, size, scale);
			_g_free0 (icon_key);
			icon_key = _tmp9_;
			if (ignore_cache) {
				_tmp10_ = TRUE;
			} else {
				GHashTable* _tmp11_;
				const gchar* _tmp12_;
				gconstpointer _tmp13_;
				GdkPixbuf* _tmp14_;
				GdkPixbuf* _tmp15_;
				_tmp11_ = gala_utils_icon_pixbuf_cache;
				_tmp12_ = icon_key;
				_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
				_tmp14_ = _g_object_ref0 ((GdkPixbuf*) _tmp13_);
				_g_object_unref0 (image);
				image = _tmp14_;
				_tmp15_ = image;
				_tmp10_ = _tmp15_ == NULL;
			}
			if (_tmp10_) {
				gint scaled_size = 0;
				cairo_surface_t* surface = NULL;
				const gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				cairo_surface_t* _tmp19_;
				cairo_surface_t* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				GdkPixbuf* _tmp23_;
				scaled_size = size * scale;
				_tmp16_ = icon;
				_tmp17_ = scaled_size;
				_tmp18_ = scaled_size;
				_tmp19_ = plank_drawing_service_load_icon_for_scale (_tmp16_, _tmp17_, _tmp18_, scale);
				surface = _tmp19_;
				_tmp20_ = surface;
				_tmp21_ = scaled_size;
				_tmp22_ = scaled_size;
				_tmp23_ = gdk_pixbuf_get_from_surface (_tmp20_, 0, 0, _tmp21_, _tmp22_);
				_g_object_unref0 (image);
				image = _tmp23_;
				not_cached = TRUE;
				_cairo_surface_destroy0 (surface);
			}
		}
		_g_object_unref0 (appinfo);
	}
	_tmp24_ = image;
	if (_tmp24_ == NULL) {
		{
			GtkIconTheme* icon_theme = NULL;
			GtkIconTheme* _tmp25_;
			gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			GHashTable* _tmp29_;
			const gchar* _tmp30_;
			gconstpointer _tmp31_;
			GdkPixbuf* _tmp32_;
			GdkPixbuf* _tmp33_;
			_tmp25_ = gtk_icon_theme_get_default ();
			icon_theme = _tmp25_;
			_tmp26_ = g_strdup ("application-default-icon");
			_g_free0 (icon);
			icon = _tmp26_;
			_tmp27_ = icon;
			_tmp28_ = g_strdup_printf ("%s::%i::%i", _tmp27_, size, scale);
			_g_free0 (icon_key);
			icon_key = _tmp28_;
			_tmp29_ = gala_utils_icon_pixbuf_cache;
			_tmp30_ = icon_key;
			_tmp31_ = g_hash_table_lookup (_tmp29_, _tmp30_);
			_tmp32_ = _g_object_ref0 ((GdkPixbuf*) _tmp31_);
			_g_object_unref0 (image);
			image = _tmp32_;
			_tmp33_ = image;
			if (_tmp33_ == NULL) {
				GdkPixbuf* _tmp34_ = NULL;
				GtkIconTheme* _tmp35_;
				const gchar* _tmp36_;
				GdkPixbuf* _tmp37_;
				GdkPixbuf* _tmp38_;
				_tmp35_ = icon_theme;
				_tmp36_ = icon;
				_tmp37_ = gtk_icon_theme_load_icon_for_scale (_tmp35_, _tmp36_, size, scale, 0, &_inner_error_);
				_tmp34_ = _tmp37_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp38_ = _tmp34_;
				_tmp34_ = NULL;
				_g_object_unref0 (image);
				image = _tmp38_;
				not_cached = TRUE;
				_g_object_unref0 (_tmp34_);
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp39_;
			const gchar* _tmp40_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp39_ = e;
			_tmp40_ = _tmp39_->message;
			g_warning ("Utils.vala:158: %s", _tmp40_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (icon_key);
			_g_free0 (icon);
			_g_object_unref0 (image);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp41_ = image;
	if (_tmp41_ == NULL) {
		gchar* _tmp42_;
		gchar* _tmp43_;
		GHashTable* _tmp44_;
		const gchar* _tmp45_;
		gconstpointer _tmp46_;
		GdkPixbuf* _tmp47_;
		GdkPixbuf* _tmp48_;
		_tmp42_ = g_strdup ("");
		_g_free0 (icon);
		icon = _tmp42_;
		_tmp43_ = g_strdup_printf ("::%i", size);
		_g_free0 (icon_key);
		icon_key = _tmp43_;
		_tmp44_ = gala_utils_icon_pixbuf_cache;
		_tmp45_ = icon_key;
		_tmp46_ = g_hash_table_lookup (_tmp44_, _tmp45_);
		_tmp47_ = _g_object_ref0 ((GdkPixbuf*) _tmp46_);
		_g_object_unref0 (image);
		image = _tmp47_;
		_tmp48_ = image;
		if (_tmp48_ == NULL) {
			GdkPixbuf* _tmp49_;
			GdkPixbuf* _tmp50_;
			_tmp49_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, size, size);
			_g_object_unref0 (image);
			image = _tmp49_;
			_tmp50_ = image;
			gdk_pixbuf_fill (_tmp50_, (guint32) 0x00000000);
			not_cached = TRUE;
		}
	}
	_tmp52_ = image;
	_tmp53_ = gdk_pixbuf_get_width (_tmp52_);
	_tmp54_ = _tmp53_;
	if ((size * scale) != _tmp54_) {
		_tmp51_ = TRUE;
	} else {
		GdkPixbuf* _tmp55_;
		gint _tmp56_;
		gint _tmp57_;
		_tmp55_ = image;
		_tmp56_ = gdk_pixbuf_get_height (_tmp55_);
		_tmp57_ = _tmp56_;
		_tmp51_ = (size * scale) != _tmp57_;
	}
	if (_tmp51_) {
		GdkPixbuf* _tmp58_;
		GdkPixbuf* _tmp59_;
		_tmp58_ = image;
		_tmp59_ = plank_drawing_service_ar_scale (_tmp58_, size * scale, size * scale);
		_g_object_unref0 (image);
		image = _tmp59_;
	}
	_tmp60_ = not_cached;
	if (_tmp60_) {
		GHashTable* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		GdkPixbuf* _tmp64_;
		GdkPixbuf* _tmp65_;
		_tmp61_ = gala_utils_icon_pixbuf_cache;
		_tmp62_ = icon_key;
		_tmp63_ = g_strdup (_tmp62_);
		_tmp64_ = image;
		_tmp65_ = _g_object_ref0 (_tmp64_);
		g_hash_table_insert (_tmp61_, _tmp63_, _tmp65_);
	}
	result = image;
	_g_free0 (icon_key);
	_g_free0 (icon);
	return result;
}


/**
 * Get the next window that should be active on a workspace right now. Based on
 * stacking order
 *
 * @param workspace The workspace on which to find the window
 * @param backward  Whether to get the previous one instead
 */
MetaWindow*
gala_utils_get_next_window (MetaWorkspace* workspace,
                            gboolean backward)
{
	MetaWindow* result = NULL;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* display = NULL;
	MetaScreen* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	MetaWindow* window = NULL;
	MetaDisplay* _tmp5_;
	MetaWindow* _tmp6_;
	MetaWindow* _tmp7_;
	MetaWindow* _tmp8_;
	g_return_val_if_fail (workspace != NULL, NULL);
	_tmp0_ = meta_workspace_get_screen (workspace);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = meta_screen_get_display (_tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	display = _tmp4_;
	_tmp5_ = display;
	_tmp6_ = meta_display_get_tab_next (_tmp5_, META_TAB_LIST_NORMAL, workspace, NULL, backward);
	_tmp7_ = _g_object_ref0 (_tmp6_);
	window = _tmp7_;
	_tmp8_ = window;
	if (_tmp8_ == NULL) {
		MetaDisplay* _tmp9_;
		MetaWindow* _tmp10_;
		MetaWindow* _tmp11_;
		_tmp9_ = display;
		_tmp10_ = meta_display_get_tab_current (_tmp9_, META_TAB_LIST_NORMAL, workspace);
		_tmp11_ = _g_object_ref0 (_tmp10_);
		_g_object_unref0 (window);
		window = _tmp11_;
	}
	result = window;
	_g_object_unref0 (display);
	_g_object_unref0 (screen);
	return result;
}


/**
 * Get the number of toplevel windows on a workspace excluding those that are
 * on all workspaces
 *
 * @param workspace The workspace on which to count the windows
 */
guint
gala_utils_get_n_windows (MetaWorkspace* workspace)
{
	guint result = 0U;
	gint n = 0;
	GList* _tmp0_;
	g_return_val_if_fail (workspace != NULL, 0U);
	n = 0;
	_tmp0_ = meta_workspace_list_windows (workspace);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp0_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			MetaWindow* window = NULL;
			window = (MetaWindow*) window_it->data;
			{
				MetaWindow* _tmp1_;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				MetaWindow* _tmp4_;
				MetaWindowType _tmp5_;
				MetaWindowType _tmp6_;
				_tmp1_ = window;
				if (meta_window_is_always_on_all_workspaces (_tmp1_)) {
					continue;
				}
				_tmp4_ = window;
				_tmp5_ = meta_window_get_window_type (_tmp4_);
				_tmp6_ = _tmp5_;
				if (_tmp6_ == META_WINDOW_NORMAL) {
					_tmp3_ = TRUE;
				} else {
					MetaWindow* _tmp7_;
					MetaWindowType _tmp8_;
					MetaWindowType _tmp9_;
					_tmp7_ = window;
					_tmp8_ = meta_window_get_window_type (_tmp7_);
					_tmp9_ = _tmp8_;
					_tmp3_ = _tmp9_ == META_WINDOW_DIALOG;
				}
				if (_tmp3_) {
					_tmp2_ = TRUE;
				} else {
					MetaWindow* _tmp10_;
					MetaWindowType _tmp11_;
					MetaWindowType _tmp12_;
					_tmp10_ = window;
					_tmp11_ = meta_window_get_window_type (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp2_ = _tmp12_ == META_WINDOW_MODAL_DIALOG;
				}
				if (_tmp2_) {
					gint _tmp13_;
					_tmp13_ = n;
					n = _tmp13_ + 1;
				}
			}
		}
		_g_list_free0 (window_collection);
	}
	result = (guint) n;
	return result;
}


/**
 * Creates an actor showing the current contents of the given WindowActor.
 *
 * @param actor      The actor from which to create a shnapshot
 * @param inner_rect The inner (actually visible) rectangle of the window
 * @param outer_rect The outer (input region) rectangle of the window
 *
 * @return           A copy of the actor at that time or %NULL
 */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_cairo_surface_destroy0 (_data2_->surface);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean
__lambda7_ (Block2Data* _data2_,
            cairo_t* cr)
{
	gboolean result = FALSE;
	cairo_surface_t* _tmp0_;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = _data2_->surface;
	cairo_set_source_surface (cr, _tmp0_, (gdouble) 0, (gdouble) 0);
	cairo_paint (cr);
	result = FALSE;
	return result;
}


static gboolean
___lambda7__clutter_canvas_draw (ClutterCanvas* _sender,
                                 cairo_t* cr,
                                 gint width,
                                 gint height,
                                 gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, cr);
	return result;
}


ClutterActor*
gala_utils_get_window_actor_snapshot (MetaWindowActor* actor,
                                      MetaRectangle* inner_rect,
                                      MetaRectangle* outer_rect)
{
	ClutterActor* result = NULL;
	Block2Data* _data2_;
	MetaShapedTexture* texture = NULL;
	ClutterActor* _tmp0_;
	MetaShapedTexture* _tmp1_;
	MetaShapedTexture* _tmp2_;
	MetaShapedTexture* _tmp3_;
	MetaRectangle _tmp4_;
	gint _tmp5_;
	MetaRectangle _tmp6_;
	gint _tmp7_;
	MetaRectangle _tmp8_;
	gint _tmp9_;
	MetaRectangle _tmp10_;
	gint _tmp11_;
	MetaRectangle _tmp12_;
	gint _tmp13_;
	MetaRectangle _tmp14_;
	gint _tmp15_;
	cairo_rectangle_int_t _tmp16_ = {0};
	cairo_surface_t* _tmp17_;
	cairo_surface_t* _tmp18_;
	ClutterCanvas* canvas = NULL;
	ClutterCanvas* _tmp19_;
	gulong handler = 0UL;
	ClutterCanvas* _tmp20_;
	gulong _tmp21_;
	ClutterCanvas* _tmp22_;
	MetaRectangle _tmp23_;
	gint _tmp24_;
	MetaRectangle _tmp25_;
	gint _tmp26_;
	ClutterCanvas* _tmp27_;
	gulong _tmp28_;
	ClutterActor* container = NULL;
	ClutterActor* _tmp29_;
	ClutterActor* _tmp30_;
	MetaRectangle _tmp31_;
	gint _tmp32_;
	MetaRectangle _tmp33_;
	gint _tmp34_;
	ClutterActor* _tmp35_;
	ClutterCanvas* _tmp36_;
	g_return_val_if_fail (actor != NULL, NULL);
	g_return_val_if_fail (inner_rect != NULL, NULL);
	g_return_val_if_fail (outer_rect != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_tmp0_ = meta_window_actor_get_texture (actor);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, meta_shaped_texture_get_type ()) ? ((MetaShapedTexture*) _tmp0_) : NULL);
	texture = _tmp1_;
	_tmp2_ = texture;
	if (_tmp2_ == NULL) {
		result = NULL;
		_g_object_unref0 (texture);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return result;
	}
	_tmp3_ = texture;
	_tmp4_ = *inner_rect;
	_tmp5_ = _tmp4_.x;
	_tmp6_ = *outer_rect;
	_tmp7_ = _tmp6_.x;
	_tmp8_ = *inner_rect;
	_tmp9_ = _tmp8_.y;
	_tmp10_ = *outer_rect;
	_tmp11_ = _tmp10_.y;
	_tmp12_ = *inner_rect;
	_tmp13_ = _tmp12_.width;
	_tmp14_ = *inner_rect;
	_tmp15_ = _tmp14_.height;
	_tmp16_.x = _tmp5_ - _tmp7_;
	_tmp16_.y = _tmp9_ - _tmp11_;
	_tmp16_.width = _tmp13_;
	_tmp16_.height = _tmp15_;
	_tmp17_ = meta_shaped_texture_get_image (_tmp3_, &_tmp16_);
	_data2_->surface = _tmp17_;
	_tmp18_ = _data2_->surface;
	if (_tmp18_ == NULL) {
		result = NULL;
		_g_object_unref0 (texture);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return result;
	}
	_tmp19_ = (ClutterCanvas*) clutter_canvas_new ();
	canvas = _tmp19_;
	_tmp20_ = canvas;
	_tmp21_ = g_signal_connect_data (_tmp20_, "draw", (GCallback) ___lambda7__clutter_canvas_draw, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	handler = _tmp21_;
	_tmp22_ = canvas;
	_tmp23_ = *inner_rect;
	_tmp24_ = _tmp23_.width;
	_tmp25_ = *inner_rect;
	_tmp26_ = _tmp25_.height;
	clutter_canvas_set_size (_tmp22_, _tmp24_, _tmp26_);
	_tmp27_ = canvas;
	_tmp28_ = handler;
	g_signal_handler_disconnect (_tmp27_, _tmp28_);
	_tmp29_ = clutter_actor_new ();
	g_object_ref_sink (_tmp29_);
	container = _tmp29_;
	_tmp30_ = container;
	_tmp31_ = *inner_rect;
	_tmp32_ = _tmp31_.width;
	_tmp33_ = *inner_rect;
	_tmp34_ = _tmp33_.height;
	clutter_actor_set_size (_tmp30_, (gfloat) _tmp32_, (gfloat) _tmp34_);
	_tmp35_ = container;
	_tmp36_ = canvas;
	clutter_actor_set_content (_tmp35_, (ClutterContent*) _tmp36_);
	result = container;
	_g_object_unref0 (canvas);
	_g_object_unref0 (texture);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}


/**
 * Ring the system bell, will most likely emit a <beep> error sound or, if the
 * audible bell is disabled, flash the screen
 *
 * @param screen The screen to flash, if necessary
 */
void
gala_utils_bell (MetaScreen* screen)
{
	g_return_if_fail (screen != NULL);
	if (meta_prefs_bell_is_audible ()) {
		gdk_beep ();
	} else {
		MetaDisplay* _tmp0_;
		MetaCompositor* _tmp1_;
		_tmp0_ = meta_screen_get_display (screen);
		_tmp1_ = meta_display_get_compositor (_tmp0_);
		meta_compositor_flash_screen (_tmp1_, screen);
	}
}


/**
 * Returns the pixbuf that is used for close buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf*
gala_utils_get_close_button_pixbuf (void)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GError * _inner_error_ = NULL;
	_tmp0_ = gala_utils_close_pixbuf;
	if (_tmp0_ == NULL) {
		gint scale = 0;
		MetaBackend* _tmp1_;
		MetaSettings* _tmp2_;
		_tmp1_ = meta_get_backend ();
		_tmp2_ = meta_backend_get_settings (_tmp1_);
		scale = meta_settings_get_ui_scaling_factor (_tmp2_);
		{
			GdkPixbuf* _tmp3_ = NULL;
			gint _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
			_tmp4_ = scale;
			_tmp5_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/close.svg", -1, 36 * _tmp4_, TRUE, &_inner_error_);
			_tmp3_ = _tmp5_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch1_g_error;
			}
			_tmp6_ = _tmp3_;
			_tmp3_ = NULL;
			_g_object_unref0 (gala_utils_close_pixbuf);
			gala_utils_close_pixbuf = _tmp6_;
			_g_object_unref0 (_tmp3_);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_warning ("Utils.vala:296: %s", _tmp8_);
			result = NULL;
			_g_error_free0 (e);
			return result;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp9_ = gala_utils_close_pixbuf;
	_tmp10_ = _g_object_ref0 (_tmp9_);
	result = _tmp10_;
	return result;
}


/**
 * Creates a new reactive ClutterActor at 36px with the close pixbuf
 *
 * @return The close button actor
 */
ClutterActor*
gala_utils_create_close_button (void)
{
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
	g_object_ref_sink (_tmp0_);
	texture = _tmp0_;
	_tmp1_ = gala_utils_get_close_button_pixbuf ();
	pixbuf = _tmp1_;
	_tmp2_ = texture;
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
	_tmp3_ = pixbuf;
	if (_tmp3_ != NULL) {
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			ClutterTexture* _tmp6_;
			GdkPixbuf* _tmp7_;
			guint8* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			_tmp5_ = pixbuf;
			if (gdk_pixbuf_get_has_alpha (_tmp5_)) {
				_tmp4_ = 4;
			} else {
				_tmp4_ = 3;
			}
			_tmp6_ = texture;
			_tmp7_ = pixbuf;
			_tmp8_ = gdk_pixbuf_get_pixels (_tmp7_);
			_tmp9_ = pixbuf;
			_tmp10_ = pixbuf;
			_tmp11_ = pixbuf;
			_tmp12_ = pixbuf;
			clutter_texture_set_from_rgb_data (_tmp6_, _tmp8_, gdk_pixbuf_get_has_alpha (_tmp9_), gdk_pixbuf_get_width (_tmp10_), gdk_pixbuf_get_height (_tmp11_), gdk_pixbuf_get_rowstride (_tmp12_), _tmp4_, 0, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (pixbuf);
			_g_object_unref0 (texture);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	} else {
		gint scale = 0;
		MetaBackend* _tmp13_;
		MetaSettings* _tmp14_;
		ClutterTexture* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		ClutterTexture* _tmp18_;
		ClutterColor _tmp19_ = {0};
		_tmp13_ = meta_get_backend ();
		_tmp14_ = meta_backend_get_settings (_tmp13_);
		scale = meta_settings_get_ui_scaling_factor (_tmp14_);
		_tmp15_ = texture;
		_tmp16_ = scale;
		_tmp17_ = scale;
		clutter_actor_set_size ((ClutterActor*) _tmp15_, (gfloat) (36 * _tmp16_), (gfloat) (36 * _tmp17_));
		_tmp18_ = texture;
		_tmp19_.red = (guint8) 255;
		_tmp19_.green = (guint8) 0;
		_tmp19_.blue = (guint8) 0;
		_tmp19_.alpha = (guint8) 255;
		clutter_actor_set_background_color ((ClutterActor*) _tmp18_, &_tmp19_);
	}
	result = (ClutterActor*) texture;
	_g_object_unref0 (pixbuf);
	return result;
}


/**
 * Returns the pixbuf that is used for resize buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf*
gala_utils_get_resize_button_pixbuf (void)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GError * _inner_error_ = NULL;
	_tmp0_ = gala_utils_resize_pixbuf;
	if (_tmp0_ == NULL) {
		gint scale = 0;
		MetaBackend* _tmp1_;
		MetaSettings* _tmp2_;
		_tmp1_ = meta_get_backend ();
		_tmp2_ = meta_backend_get_settings (_tmp1_);
		scale = meta_settings_get_ui_scaling_factor (_tmp2_);
		{
			GdkPixbuf* _tmp3_ = NULL;
			gint _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
			_tmp4_ = scale;
			_tmp5_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/resize.svg", -1, 36 * _tmp4_, TRUE, &_inner_error_);
			_tmp3_ = _tmp5_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch3_g_error;
			}
			_tmp6_ = _tmp3_;
			_tmp3_ = NULL;
			_g_object_unref0 (gala_utils_resize_pixbuf);
			gala_utils_resize_pixbuf = _tmp6_;
			_g_object_unref0 (_tmp3_);
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_warning ("Utils.vala:354: %s", _tmp8_);
			result = NULL;
			_g_error_free0 (e);
			return result;
		}
		__finally3:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp9_ = gala_utils_resize_pixbuf;
	_tmp10_ = _g_object_ref0 (_tmp9_);
	result = _tmp10_;
	return result;
}


/**
 * Creates a new reactive ClutterActor at 36px with the resize pixbuf
 *
 * @return The resize button actor
 */
ClutterActor*
gala_utils_create_resize_button (void)
{
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
	g_object_ref_sink (_tmp0_);
	texture = _tmp0_;
	_tmp1_ = gala_utils_get_resize_button_pixbuf ();
	pixbuf = _tmp1_;
	_tmp2_ = texture;
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
	_tmp3_ = pixbuf;
	if (_tmp3_ != NULL) {
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			ClutterTexture* _tmp6_;
			GdkPixbuf* _tmp7_;
			guint8* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			_tmp5_ = pixbuf;
			if (gdk_pixbuf_get_has_alpha (_tmp5_)) {
				_tmp4_ = 4;
			} else {
				_tmp4_ = 3;
			}
			_tmp6_ = texture;
			_tmp7_ = pixbuf;
			_tmp8_ = gdk_pixbuf_get_pixels (_tmp7_);
			_tmp9_ = pixbuf;
			_tmp10_ = pixbuf;
			_tmp11_ = pixbuf;
			_tmp12_ = pixbuf;
			clutter_texture_set_from_rgb_data (_tmp6_, _tmp8_, gdk_pixbuf_get_has_alpha (_tmp9_), gdk_pixbuf_get_width (_tmp10_), gdk_pixbuf_get_height (_tmp11_), gdk_pixbuf_get_rowstride (_tmp12_), _tmp4_, 0, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally4:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (pixbuf);
			_g_object_unref0 (texture);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	} else {
		gint scale = 0;
		MetaBackend* _tmp13_;
		MetaSettings* _tmp14_;
		ClutterTexture* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		ClutterTexture* _tmp18_;
		ClutterColor _tmp19_ = {0};
		_tmp13_ = meta_get_backend ();
		_tmp14_ = meta_backend_get_settings (_tmp13_);
		scale = meta_settings_get_ui_scaling_factor (_tmp14_);
		_tmp15_ = texture;
		_tmp16_ = scale;
		_tmp17_ = scale;
		clutter_actor_set_size ((ClutterActor*) _tmp15_, (gfloat) (36 * _tmp16_), (gfloat) (36 * _tmp17_));
		_tmp18_ = texture;
		_tmp19_.red = (guint8) 255;
		_tmp19_.green = (guint8) 0;
		_tmp19_.blue = (guint8) 0;
		_tmp19_.alpha = (guint8) 255;
		clutter_actor_set_background_color ((ClutterActor*) _tmp18_, &_tmp19_);
	}
	result = (ClutterActor*) texture;
	_g_object_unref0 (pixbuf);
	return result;
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void
gala_value_utils_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
gala_value_utils_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gala_utils_unref (value->data[0].v_pointer);
	}
}


static void
gala_value_utils_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gala_utils_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
gala_value_utils_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
gala_value_utils_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GalaUtils * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gala_utils_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
gala_value_utils_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	GalaUtils ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gala_utils_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
gala_param_spec_utils (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	GalaParamSpecUtils* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GALA_TYPE_UTILS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
gala_value_get_utils (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS), NULL);
	return value->data[0].v_pointer;
}


void
gala_value_set_utils (GValue* value,
                      gpointer v_object)
{
	GalaUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gala_utils_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gala_utils_unref (old);
	}
}


void
gala_value_take_utils (GValue* value,
                       gpointer v_object)
{
	GalaUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gala_utils_unref (old);
	}
}


static void
gala_utils_class_init (GalaUtilsClass * klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	gala_utils_parent_class = g_type_class_peek_parent (klass);
	((GalaUtilsClass *) klass)->finalize = gala_utils_finalize;
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (gala_utils_xid_pixbuf_cache);
	gala_utils_xid_pixbuf_cache = _tmp2_;
	_tmp3_ = g_str_hash;
	_tmp4_ = g_str_equal;
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (gala_utils_icon_pixbuf_cache);
	gala_utils_icon_pixbuf_cache = _tmp5_;
}


static void
gala_utils_instance_init (GalaUtils * self)
{
	self->ref_count = 1;
}


static void
gala_utils_finalize (GalaUtils * obj)
{
	GalaUtils * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_UTILS, GalaUtils);
	g_signal_handlers_destroy (self);
}


GType
gala_utils_get_type (void)
{
	static volatile gsize gala_utils_type_id__volatile = 0;
	if (g_once_init_enter (&gala_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gala_value_utils_init, gala_value_utils_free_value, gala_value_utils_copy_value, gala_value_utils_peek_pointer, "p", gala_value_utils_collect_value, "p", gala_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GalaUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaUtils), 0, (GInstanceInitFunc) gala_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gala_utils_type_id;
		gala_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gala_utils_type_id__volatile, gala_utils_type_id);
	}
	return gala_utils_type_id__volatile;
}


gpointer
gala_utils_ref (gpointer instance)
{
	GalaUtils * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
gala_utils_unref (gpointer instance)
{
	GalaUtils * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GALA_UTILS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



