/* DragDropAction.c generated by valac 0.40.6, the Vala compiler
 * generated from DragDropAction.vala, do not modify */

/**/
/*  Copyright (C) 2013 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gee.h>


#define GALA_TYPE_DRAG_DROP_ACTION_TYPE (gala_drag_drop_action_type_get_type ())

#define GALA_TYPE_DRAG_DROP_ACTION (gala_drag_drop_action_get_type ())
#define GALA_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction))
#define GALA_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))
#define GALA_IS_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_IS_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_DRAG_DROP_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))

typedef struct _GalaDragDropAction GalaDragDropAction;
typedef struct _GalaDragDropActionClass GalaDragDropActionClass;
typedef struct _GalaDragDropActionPrivate GalaDragDropActionPrivate;
enum  {
	GALA_DRAG_DROP_ACTION_0_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY,
	GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY,
	GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY,
	GALA_DRAG_DROP_ACTION_NUM_PROPERTIES
};
static GParamSpec* gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
enum  {
	GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL,
	GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL,
	GALA_DRAG_DROP_ACTION_NUM_SIGNALS
};
static guint gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_NUM_SIGNALS] = {0};

typedef enum  {
	GALA_DRAG_DROP_ACTION_TYPE_SOURCE = 0,
	GALA_DRAG_DROP_ACTION_TYPE_DESTINATION
} GalaDragDropActionType;

struct _GalaDragDropAction {
	ClutterAction parent_instance;
	GalaDragDropActionPrivate * priv;
};

struct _GalaDragDropActionClass {
	ClutterActionClass parent_class;
};

struct _GalaDragDropActionPrivate {
	GalaDragDropActionType _drag_type;
	gchar* _drag_id;
	ClutterActor* _handle;
	gboolean _dragging;
	gboolean _allow_bubbling;
	ClutterActor* hovered;
	gboolean clicked;
	gfloat last_x;
	gfloat last_y;
};


static gpointer gala_drag_drop_action_parent_class = NULL;
static GeeHashMap* gala_drag_drop_action_sources;
static GeeHashMap* gala_drag_drop_action_sources = NULL;

GType gala_drag_drop_action_type_get_type (void) G_GNUC_CONST;
GType gala_drag_drop_action_get_type (void) G_GNUC_CONST;
#define GALA_DRAG_DROP_ACTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionPrivate))
static void gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
GalaDragDropAction* gala_drag_drop_action_new (GalaDragDropActionType type,
                                               const gchar* id);
GalaDragDropAction* gala_drag_drop_action_construct (GType object_type,
                                                     GalaDragDropActionType type,
                                                     const gchar* id);
static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                           ClutterActor* new_actor);
static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
GalaDragDropActionType gala_drag_drop_action_get_drag_type (GalaDragDropAction* self);
static gboolean gala_drag_drop_action_source_clicked (GalaDragDropAction* self,
                                               ClutterButtonEvent* event);
static gboolean _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                 ClutterButtonEvent* event,
                                                                                 gpointer self);
const gchar* gala_drag_drop_action_get_drag_id (GalaDragDropAction* self);
static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                         ClutterActor* destination,
                                         gboolean hovered);
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                                                ClutterActor* actor);
static gboolean gala_drag_drop_action_follow_move (GalaDragDropAction* self,
                                            ClutterEvent* event);
static gboolean _gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender,
                                                                          ClutterEvent* event,
                                                                          gpointer self);
gboolean gala_drag_drop_action_get_dragging (GalaDragDropAction* self);
static void gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                       ClutterActor* value);
ClutterActor* gala_drag_drop_action_get_handle (GalaDragDropAction* self);
static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                         gboolean value);
void gala_drag_drop_action_cancel (GalaDragDropAction* self);
gboolean gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self);
static void gala_drag_drop_action_finish (GalaDragDropAction* self);
static void gala_drag_drop_action_cleanup (GalaDragDropAction* self);
void gala_drag_drop_action_cancel_all_by_id (const gchar* id);
static void gala_drag_drop_action_set_drag_type (GalaDragDropAction* self,
                                          GalaDragDropActionType value);
static void gala_drag_drop_action_set_drag_id (GalaDragDropAction* self,
                                        const gchar* value);
void gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self,
                                               gboolean value);
static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void gala_drag_drop_action_finalize (GObject * obj);
static void _vala_gala_drag_drop_action_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gala_drag_drop_action_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);


GType
gala_drag_drop_action_type_get_type (void)
{
	static volatile gsize gala_drag_drop_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "GALA_DRAG_DROP_ACTION_TYPE_SOURCE", "source"}, {GALA_DRAG_DROP_ACTION_TYPE_DESTINATION, "GALA_DRAG_DROP_ACTION_TYPE_DESTINATION", "destination"}, {0, NULL, NULL}};
		GType gala_drag_drop_action_type_type_id;
		gala_drag_drop_action_type_type_id = g_enum_register_static ("GalaDragDropActionType", values);
		g_once_init_leave (&gala_drag_drop_action_type_type_id__volatile, gala_drag_drop_action_type_type_id);
	}
	return gala_drag_drop_action_type_type_id__volatile;
}


/**
 * Create a new DragDropAction
 *
 * @param type The type of this actor
 * @param id   An ID that marks which sources can be dragged on
 *             which destinations. It has to be the same for all actors that
 *             should be compatible with each other.
 */
GalaDragDropAction*
gala_drag_drop_action_construct (GType object_type,
                                 GalaDragDropActionType type,
                                 const gchar* id)
{
	GalaDragDropAction * self = NULL;
	GeeHashMap* _tmp0_;
	g_return_val_if_fail (id != NULL, NULL);
	self = (GalaDragDropAction*) g_object_new (object_type, "drag-type", type, "drag-id", id, NULL);
	_tmp0_ = gala_drag_drop_action_sources;
	if (_tmp0_ == NULL) {
		GeeHashMap* _tmp1_;
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		_g_object_unref0 (gala_drag_drop_action_sources);
		gala_drag_drop_action_sources = _tmp1_;
	}
	return self;
}


GalaDragDropAction*
gala_drag_drop_action_new (GalaDragDropActionType type,
                           const gchar* id)
{
	return gala_drag_drop_action_construct (GALA_TYPE_DRAG_DROP_ACTION, type, id);
}


static void
gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                      ClutterActor* new_actor)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	self = (GalaDragDropAction*) base;
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
		_tmp3_ = _tmp2_;
		gala_drag_drop_action_release_actor (self, _tmp3_);
	}
	if (new_actor != NULL) {
		gala_drag_drop_action_connect_actor (self, new_actor);
	}
	CLUTTER_ACTOR_META_CLASS (gala_drag_drop_action_parent_class)->set_actor ((ClutterActorMeta*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_action_get_type (), ClutterAction), new_actor);
}


static gboolean
_gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                        ClutterButtonEvent* event,
                                                                        gpointer self)
{
	gboolean result;
	result = gala_drag_drop_action_source_clicked ((GalaDragDropAction*) self, event);
	return result;
}


static void
gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (actor != NULL);
	_tmp0_ = self->priv->_drag_type;
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
		guint _tmp1_;
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp2_;
		const gchar* _tmp3_;
		gpointer _tmp4_;
		GeeLinkedList* _tmp5_;
		g_signal_parse_name ("button-press-event", clutter_actor_get_type (), &_tmp1_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (actor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self);
		_tmp2_ = gala_drag_drop_action_sources;
		_tmp3_ = self->priv->_drag_id;
		_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
		source_list = (GeeLinkedList*) _tmp4_;
		_tmp5_ = source_list;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp5_, actor);
		_g_object_unref0 (source_list);
	}
}


static void
gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (actor != NULL);
	_tmp0_ = self->priv->_drag_type;
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp1_;
		const gchar* _tmp2_;
		gpointer _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeLinkedList* _tmp9_;
		g_signal_connect_object (actor, "button-press-event", (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self, 0);
		_tmp1_ = gala_drag_drop_action_sources;
		_tmp2_ = self->priv->_drag_id;
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp2_);
		source_list = (GeeLinkedList*) _tmp3_;
		_tmp4_ = source_list;
		if (_tmp4_ == NULL) {
			GeeLinkedList* _tmp5_;
			GeeHashMap* _tmp6_;
			const gchar* _tmp7_;
			GeeLinkedList* _tmp8_;
			_tmp5_ = gee_linked_list_new (clutter_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			_g_object_unref0 (source_list);
			source_list = _tmp5_;
			_tmp6_ = gala_drag_drop_action_sources;
			_tmp7_ = self->priv->_drag_id;
			_tmp8_ = source_list;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, _tmp8_);
		}
		_tmp9_ = source_list;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, actor);
		_g_object_unref0 (source_list);
	}
}


static void
gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                    ClutterActor* destination,
                                    gboolean hovered)
{
	GalaDragDropAction* _tmp0_;
	GalaDragDropAction* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (destination != NULL);
	_tmp0_ = gala_drag_drop_action_get_drag_drop_action (self, destination);
	_tmp1_ = _tmp0_;
	g_signal_emit (_tmp1_, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL], 0, hovered);
	_g_object_unref0 (_tmp1_);
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL], 0, destination, hovered);
}


static gboolean
_gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender,
                                                                 ClutterEvent* event,
                                                                 gpointer self)
{
	gboolean result;
	result = gala_drag_drop_action_follow_move ((GalaDragDropAction*) self, event);
	return result;
}


static gboolean
gala_drag_drop_action_source_clicked (GalaDragDropAction* self,
                                      ClutterButtonEvent* event)
{
	gboolean result = FALSE;
	guint32 _tmp0_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterStage* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->button;
	if (_tmp0_ != ((guint32) 1)) {
		guint32 _tmp1_;
		_tmp1_ = event->button;
		g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, _tmp1_);
		result = FALSE;
		return result;
	}
	_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = clutter_actor_get_stage (_tmp3_);
	g_signal_connect_object ((ClutterActor*) _tmp4_, "captured-event", (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self, 0);
	self->priv->clicked = TRUE;
	_tmp5_ = event->x;
	self->priv->last_x = _tmp5_;
	_tmp6_ = event->y;
	self->priv->last_y = _tmp6_;
	result = TRUE;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static gboolean
gala_drag_drop_action_follow_move (GalaDragDropAction* self,
                                   ClutterEvent* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_dragging;
	if (!_tmp0_) {
		switch (clutter_event_type (event)) {
			case CLUTTER_MOTION:
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat _tmp1_ = 0.0F;
				gfloat _tmp2_ = 0.0F;
				gint drag_threshold = 0;
				ClutterSettings* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gboolean _tmp6_ = FALSE;
				gfloat _tmp7_;
				gfloat _tmp8_;
				gint _tmp9_;
				clutter_event_get_coords (event, &_tmp1_, &_tmp2_);
				x = _tmp1_;
				y = _tmp2_;
				_tmp3_ = clutter_settings_get_default ();
				g_object_get (_tmp3_, "dnd-drag-threshold", &_tmp4_, NULL);
				_tmp5_ = _tmp4_;
				drag_threshold = _tmp5_;
				_tmp7_ = self->priv->last_x;
				_tmp8_ = x;
				_tmp9_ = drag_threshold;
				if (fabsf (_tmp7_ - _tmp8_) > ((gfloat) _tmp9_)) {
					_tmp6_ = TRUE;
				} else {
					gfloat _tmp10_;
					gfloat _tmp11_;
					gint _tmp12_;
					_tmp10_ = self->priv->last_y;
					_tmp11_ = y;
					_tmp12_ = drag_threshold;
					_tmp6_ = fabsf (_tmp10_ - _tmp11_) > ((gfloat) _tmp12_);
				}
				if (_tmp6_) {
					gfloat _tmp13_;
					gfloat _tmp14_;
					ClutterActor* _tmp15_ = NULL;
					ClutterActor* _tmp16_;
					ClutterActor* _tmp17_;
					ClutterActor* _tmp22_;
					GeeLinkedList* source_list = NULL;
					GeeHashMap* _tmp23_;
					const gchar* _tmp24_;
					gpointer _tmp25_;
					GeeLinkedList* _tmp26_;
					_tmp13_ = x;
					_tmp14_ = y;
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL], 0, _tmp13_, _tmp14_, &_tmp15_);
					_tmp16_ = _tmp15_;
					gala_drag_drop_action_set_handle (self, _tmp16_);
					_g_object_unref0 (_tmp16_);
					_tmp17_ = self->priv->_handle;
					if (_tmp17_ == NULL) {
						ClutterActor* _tmp18_;
						ClutterActor* _tmp19_;
						ClutterStage* _tmp20_;
						guint _tmp21_;
						_tmp18_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
						_tmp19_ = _tmp18_;
						_tmp20_ = clutter_actor_get_stage (_tmp19_);
						g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp21_, NULL, FALSE);
						g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
						g_critical ("DragDropAction.vala:200: No handle has been returned by the started si" \
"gnal, aborting drag.");
						result = FALSE;
						return result;
					}
					_tmp22_ = self->priv->_handle;
					clutter_actor_set_reactive (_tmp22_, FALSE);
					self->priv->clicked = FALSE;
					gala_drag_drop_action_set_dragging (self, TRUE);
					_tmp23_ = gala_drag_drop_action_sources;
					_tmp24_ = self->priv->_drag_id;
					_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, _tmp24_);
					source_list = (GeeLinkedList*) _tmp25_;
					_tmp26_ = source_list;
					if (_tmp26_ != NULL) {
						{
							GeeLinkedList* _actor_list = NULL;
							GeeLinkedList* _tmp27_;
							GeeLinkedList* _tmp28_;
							gint _actor_size = 0;
							GeeLinkedList* _tmp29_;
							gint _tmp30_;
							gint _tmp31_;
							gint _actor_index = 0;
							_tmp27_ = source_list;
							_tmp28_ = _g_object_ref0 (_tmp27_);
							_actor_list = _tmp28_;
							_tmp29_ = _actor_list;
							_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
							_tmp31_ = _tmp30_;
							_actor_size = _tmp31_;
							_actor_index = -1;
							while (TRUE) {
								gint _tmp32_;
								gint _tmp33_;
								gint _tmp34_;
								ClutterActor* actor = NULL;
								GeeLinkedList* _tmp35_;
								gint _tmp36_;
								gpointer _tmp37_;
								ClutterActor* _tmp38_;
								_tmp32_ = _actor_index;
								_actor_index = _tmp32_ + 1;
								_tmp33_ = _actor_index;
								_tmp34_ = _actor_size;
								if (!(_tmp33_ < _tmp34_)) {
									break;
								}
								_tmp35_ = _actor_list;
								_tmp36_ = _actor_index;
								_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, _tmp36_);
								actor = (ClutterActor*) _tmp37_;
								_tmp38_ = actor;
								clutter_actor_set_reactive (_tmp38_, FALSE);
								_g_object_unref0 (actor);
							}
							_g_object_unref0 (_actor_list);
						}
					}
					_g_object_unref0 (source_list);
				}
				result = TRUE;
				return result;
			}
			case CLUTTER_BUTTON_RELEASE:
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat ex = 0.0F;
				gfloat ey = 0.0F;
				gfloat _tmp39_ = 0.0F;
				gfloat _tmp40_ = 0.0F;
				ClutterActor* _tmp41_;
				ClutterActor* _tmp42_;
				gfloat _tmp43_ = 0.0F;
				gfloat _tmp44_ = 0.0F;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
				gfloat _tmp48_;
				gfloat _tmp49_;
				ClutterActor* _tmp64_;
				ClutterActor* _tmp65_;
				ClutterStage* _tmp66_;
				guint _tmp67_;
				clutter_event_get_coords (event, &_tmp39_, &_tmp40_);
				ex = _tmp39_;
				ey = _tmp40_;
				_tmp41_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
				_tmp42_ = _tmp41_;
				clutter_actor_get_transformed_position (_tmp42_, &_tmp43_, &_tmp44_);
				x = _tmp43_;
				y = _tmp44_;
				_tmp48_ = x;
				_tmp49_ = ex;
				if (_tmp48_ < _tmp49_) {
					gfloat _tmp50_;
					ClutterActor* _tmp51_;
					ClutterActor* _tmp52_;
					gfloat _tmp53_;
					gfloat _tmp54_;
					gfloat _tmp55_;
					_tmp50_ = x;
					_tmp51_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
					_tmp52_ = _tmp51_;
					_tmp53_ = clutter_actor_get_width (_tmp52_);
					_tmp54_ = _tmp53_;
					_tmp55_ = ex;
					_tmp47_ = (_tmp50_ + _tmp54_) > _tmp55_;
				} else {
					_tmp47_ = FALSE;
				}
				if (_tmp47_) {
					gfloat _tmp56_;
					gfloat _tmp57_;
					_tmp56_ = y;
					_tmp57_ = ey;
					_tmp46_ = _tmp56_ < _tmp57_;
				} else {
					_tmp46_ = FALSE;
				}
				if (_tmp46_) {
					gfloat _tmp58_;
					ClutterActor* _tmp59_;
					ClutterActor* _tmp60_;
					gfloat _tmp61_;
					gfloat _tmp62_;
					gfloat _tmp63_;
					_tmp58_ = y;
					_tmp59_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
					_tmp60_ = _tmp59_;
					_tmp61_ = clutter_actor_get_height (_tmp60_);
					_tmp62_ = _tmp61_;
					_tmp63_ = ey;
					_tmp45_ = (_tmp58_ + _tmp62_) > _tmp63_;
				} else {
					_tmp45_ = FALSE;
				}
				if (_tmp45_) {
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, clutter_event_get_button (event));
				}
				_tmp64_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
				_tmp65_ = _tmp64_;
				_tmp66_ = clutter_actor_get_stage (_tmp65_);
				g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp67_, NULL, FALSE);
				g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp66_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp67_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
				self->priv->clicked = FALSE;
				gala_drag_drop_action_set_dragging (self, FALSE);
				result = TRUE;
				return result;
			}
			default:
			{
				result = TRUE;
				return result;
			}
		}
	}
	switch (clutter_event_type (event)) {
		case CLUTTER_KEY_PRESS:
		{
			if (((gint) clutter_event_get_key_code (event)) == CLUTTER_KEY_Escape) {
				gala_drag_drop_action_cancel (self);
			}
			result = TRUE;
			return result;
		}
		case CLUTTER_MOTION:
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			gfloat _tmp68_ = 0.0F;
			gfloat _tmp69_ = 0.0F;
			ClutterActor* _tmp70_;
			ClutterActor* _tmp71_;
			gfloat _tmp72_;
			gfloat _tmp73_;
			gfloat _tmp74_;
			gfloat _tmp75_;
			ClutterActor* _tmp76_;
			ClutterActor* _tmp77_;
			gfloat _tmp78_;
			gfloat _tmp79_;
			gfloat _tmp80_;
			gfloat _tmp81_;
			gfloat _tmp82_;
			gfloat _tmp83_;
			ClutterStage* stage = NULL;
			ClutterActor* _tmp84_;
			ClutterActor* _tmp85_;
			ClutterStage* _tmp86_;
			ClutterStage* _tmp87_;
			ClutterActor* actor = NULL;
			ClutterStage* _tmp88_;
			gfloat _tmp89_;
			gfloat _tmp90_;
			ClutterActor* _tmp91_;
			ClutterActor* _tmp92_;
			GalaDragDropAction* action = NULL;
			gboolean _tmp93_ = FALSE;
			gboolean _tmp94_ = FALSE;
			ClutterActor* _tmp95_;
			ClutterActor* _tmp108_;
			ClutterActor* _tmp109_;
			GalaDragDropAction* _tmp110_;
			ClutterActor* _tmp113_;
			ClutterActor* _tmp115_;
			ClutterActor* _tmp116_;
			ClutterActor* _tmp117_;
			clutter_event_get_coords (event, &_tmp68_, &_tmp69_);
			x = _tmp68_;
			y = _tmp69_;
			_tmp70_ = self->priv->_handle;
			_tmp71_ = self->priv->_handle;
			_tmp72_ = clutter_actor_get_x (_tmp71_);
			_tmp73_ = _tmp72_;
			_tmp74_ = self->priv->last_x;
			_tmp75_ = x;
			clutter_actor_set_x (_tmp71_, _tmp73_ - (_tmp74_ - _tmp75_));
			_tmp76_ = self->priv->_handle;
			_tmp77_ = self->priv->_handle;
			_tmp78_ = clutter_actor_get_y (_tmp77_);
			_tmp79_ = _tmp78_;
			_tmp80_ = self->priv->last_y;
			_tmp81_ = y;
			clutter_actor_set_y (_tmp77_, _tmp79_ - (_tmp80_ - _tmp81_));
			_tmp82_ = x;
			self->priv->last_x = _tmp82_;
			_tmp83_ = y;
			self->priv->last_y = _tmp83_;
			_tmp84_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
			_tmp85_ = _tmp84_;
			_tmp86_ = clutter_actor_get_stage (_tmp85_);
			_tmp87_ = _g_object_ref0 (_tmp86_);
			stage = _tmp87_;
			_tmp88_ = stage;
			_tmp89_ = x;
			_tmp90_ = y;
			_tmp91_ = clutter_stage_get_actor_at_pos (_tmp88_, CLUTTER_PICK_REACTIVE, (gint) _tmp89_, (gint) _tmp90_);
			_tmp92_ = _g_object_ref0 (_tmp91_);
			actor = _tmp92_;
			action = NULL;
			_tmp95_ = actor;
			if (_tmp95_ != NULL) {
				ClutterActor* _tmp96_;
				GalaDragDropAction* _tmp97_;
				GalaDragDropAction* _tmp98_;
				_tmp96_ = actor;
				_tmp97_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp96_);
				_g_object_unref0 (action);
				action = _tmp97_;
				_tmp98_ = action;
				_tmp94_ = _tmp98_ == NULL;
			} else {
				_tmp94_ = FALSE;
			}
			if (_tmp94_) {
				gboolean _tmp99_;
				_tmp99_ = self->priv->_allow_bubbling;
				_tmp93_ = _tmp99_;
			} else {
				_tmp93_ = FALSE;
			}
			if (_tmp93_) {
				while (TRUE) {
					ClutterActor* _tmp100_;
					ClutterActor* _tmp101_;
					ClutterActor* _tmp102_;
					ClutterActor* _tmp103_;
					ClutterStage* _tmp104_;
					ClutterActor* _tmp105_;
					GalaDragDropAction* _tmp106_;
					GalaDragDropAction* _tmp107_;
					_tmp100_ = actor;
					_tmp101_ = clutter_actor_get_parent (_tmp100_);
					_tmp102_ = _g_object_ref0 (_tmp101_);
					_g_object_unref0 (actor);
					actor = _tmp102_;
					_tmp103_ = actor;
					_tmp104_ = stage;
					if (!(_tmp103_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp104_, clutter_actor_get_type (), ClutterActor))) {
						break;
					}
					_tmp105_ = actor;
					_tmp106_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp105_);
					_g_object_unref0 (action);
					action = _tmp106_;
					_tmp107_ = action;
					if (_tmp107_ != NULL) {
						break;
					}
				}
			}
			_tmp108_ = actor;
			_tmp109_ = self->priv->hovered;
			if (_tmp108_ == _tmp109_) {
				result = TRUE;
				_g_object_unref0 (action);
				_g_object_unref0 (actor);
				_g_object_unref0 (stage);
				return result;
			}
			_tmp110_ = action;
			if (_tmp110_ == NULL) {
				ClutterActor* _tmp111_;
				_tmp111_ = self->priv->hovered;
				if (_tmp111_ != NULL) {
					ClutterActor* _tmp112_;
					_tmp112_ = self->priv->hovered;
					gala_drag_drop_action_emit_crossed (self, _tmp112_, FALSE);
					_g_object_unref0 (self->priv->hovered);
					self->priv->hovered = NULL;
				}
				result = TRUE;
				_g_object_unref0 (action);
				_g_object_unref0 (actor);
				_g_object_unref0 (stage);
				return result;
			}
			_tmp113_ = self->priv->hovered;
			if (_tmp113_ != NULL) {
				ClutterActor* _tmp114_;
				_tmp114_ = self->priv->hovered;
				gala_drag_drop_action_emit_crossed (self, _tmp114_, FALSE);
			}
			_tmp115_ = actor;
			_tmp116_ = _g_object_ref0 (_tmp115_);
			_g_object_unref0 (self->priv->hovered);
			self->priv->hovered = _tmp116_;
			_tmp117_ = self->priv->hovered;
			gala_drag_drop_action_emit_crossed (self, _tmp117_, TRUE);
			result = TRUE;
			_g_object_unref0 (action);
			_g_object_unref0 (actor);
			_g_object_unref0 (stage);
			return result;
		}
		case CLUTTER_BUTTON_RELEASE:
		{
			ClutterActor* _tmp118_;
			_tmp118_ = self->priv->hovered;
			if (_tmp118_ != NULL) {
				gala_drag_drop_action_finish (self);
			} else {
				gala_drag_drop_action_cancel (self);
			}
			result = TRUE;
			return result;
		}
		case CLUTTER_ENTER:
		case CLUTTER_LEAVE:
		{
			result = TRUE;
			return result;
		}
		default:
		break;
	}
	result = FALSE;
	return result;
}


/**
 * Looks for a DragDropAction instance if this actor has one or NULL.
 * It also checks if it is a DESTINATION and if the id matches
 *
 * @return the DragDropAction instance on this actor or NULL
 */
static GalaDragDropAction*
gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                            ClutterActor* actor)
{
	GalaDragDropAction* result = NULL;
	GalaDragDropAction* drop_action = NULL;
	GList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (actor != NULL, NULL);
	drop_action = NULL;
	_tmp0_ = clutter_actor_get_actions (actor);
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
		action_collection = _tmp0_;
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
			ClutterAction* action = NULL;
			action = (ClutterAction*) action_it->data;
			{
				ClutterAction* _tmp1_;
				GalaDragDropAction* _tmp2_;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				GalaDragDropAction* _tmp5_;
				_tmp1_ = action;
				_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp1_) : NULL);
				_g_object_unref0 (drop_action);
				drop_action = _tmp2_;
				_tmp5_ = drop_action;
				if (_tmp5_ == NULL) {
					_tmp4_ = TRUE;
				} else {
					GalaDragDropAction* _tmp6_;
					GalaDragDropActionType _tmp7_;
					_tmp6_ = drop_action;
					_tmp7_ = _tmp6_->priv->_drag_type;
					_tmp4_ = _tmp7_ != GALA_DRAG_DROP_ACTION_TYPE_DESTINATION;
				}
				if (_tmp4_) {
					_tmp3_ = TRUE;
				} else {
					GalaDragDropAction* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					_tmp8_ = drop_action;
					_tmp9_ = _tmp8_->priv->_drag_id;
					_tmp10_ = self->priv->_drag_id;
					_tmp3_ = g_strcmp0 (_tmp9_, _tmp10_) != 0;
				}
				if (_tmp3_) {
					continue;
				}
				result = drop_action;
				_g_list_free0 (action_collection);
				return result;
			}
		}
		_g_list_free0 (action_collection);
	}
	result = NULL;
	_g_object_unref0 (drop_action);
	return result;
}


/**
 * Abort the drag
 */
void
gala_drag_drop_action_cancel (GalaDragDropAction* self)
{
	g_return_if_fail (self != NULL);
	gala_drag_drop_action_cleanup (self);
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL], 0);
}


/**
 * Allows you to abort all drags currently running for a given drag-id
 */
void
gala_drag_drop_action_cancel_all_by_id (const gchar* id)
{
	GeeLinkedList* actors = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeLinkedList* _tmp2_;
	g_return_if_fail (id != NULL);
	_tmp0_ = gala_drag_drop_action_sources;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, id);
	actors = (GeeLinkedList*) _tmp1_;
	_tmp2_ = actors;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (actors);
		return;
	}
	{
		GeeLinkedList* _actor_list = NULL;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		gint _actor_size = 0;
		GeeLinkedList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _actor_index = 0;
		_tmp3_ = actors;
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_actor_list = _tmp4_;
		_tmp5_ = _actor_list;
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
		_tmp7_ = _tmp6_;
		_actor_size = _tmp7_;
		_actor_index = -1;
		while (TRUE) {
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			ClutterActor* actor = NULL;
			GeeLinkedList* _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			ClutterActor* _tmp14_;
			GList* _tmp15_;
			_tmp8_ = _actor_index;
			_actor_index = _tmp8_ + 1;
			_tmp9_ = _actor_index;
			_tmp10_ = _actor_size;
			if (!(_tmp9_ < _tmp10_)) {
				break;
			}
			_tmp11_ = _actor_list;
			_tmp12_ = _actor_index;
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
			actor = (ClutterActor*) _tmp13_;
			_tmp14_ = actor;
			_tmp15_ = clutter_actor_get_actions (_tmp14_);
			{
				GList* action_collection = NULL;
				GList* action_it = NULL;
				action_collection = _tmp15_;
				for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
					ClutterAction* action = NULL;
					action = (ClutterAction*) action_it->data;
					{
						GalaDragDropAction* drag_action = NULL;
						ClutterAction* _tmp16_;
						GalaDragDropAction* _tmp17_;
						gboolean _tmp18_ = FALSE;
						GalaDragDropAction* _tmp19_;
						_tmp16_ = action;
						_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp16_) : NULL);
						drag_action = _tmp17_;
						_tmp19_ = drag_action;
						if (_tmp19_ != NULL) {
							GalaDragDropAction* _tmp20_;
							gboolean _tmp21_;
							_tmp20_ = drag_action;
							_tmp21_ = _tmp20_->priv->_dragging;
							_tmp18_ = _tmp21_;
						} else {
							_tmp18_ = FALSE;
						}
						if (_tmp18_) {
							GalaDragDropAction* _tmp22_;
							_tmp22_ = drag_action;
							gala_drag_drop_action_cancel (_tmp22_);
							_g_object_unref0 (drag_action);
							break;
						}
						_g_object_unref0 (drag_action);
					}
				}
				_g_list_free0 (action_collection);
			}
			_g_object_unref0 (actor);
		}
		_g_object_unref0 (_actor_list);
	}
	_g_object_unref0 (actors);
}


static void
gala_drag_drop_action_finish (GalaDragDropAction* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->hovered;
	gala_drag_drop_action_emit_crossed (self, _tmp0_, FALSE);
	gala_drag_drop_action_cleanup (self);
	_tmp1_ = self->priv->hovered;
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL], 0, _tmp1_);
}


static void
gala_drag_drop_action_cleanup (GalaDragDropAction* self)
{
	GeeLinkedList* source_list = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
	gboolean _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gala_drag_drop_action_sources;
	_tmp1_ = self->priv->_drag_id;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	source_list = (GeeLinkedList*) _tmp2_;
	_tmp3_ = source_list;
	if (_tmp3_ != NULL) {
		{
			GeeLinkedList* _actor_list = NULL;
			GeeLinkedList* _tmp4_;
			GeeLinkedList* _tmp5_;
			gint _actor_size = 0;
			GeeLinkedList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _actor_index = 0;
			_tmp4_ = source_list;
			_tmp5_ = _g_object_ref0 (_tmp4_);
			_actor_list = _tmp5_;
			_tmp6_ = _actor_list;
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
			_tmp8_ = _tmp7_;
			_actor_size = _tmp8_;
			_actor_index = -1;
			while (TRUE) {
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				ClutterActor* actor = NULL;
				GeeLinkedList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				ClutterActor* _tmp15_;
				_tmp9_ = _actor_index;
				_actor_index = _tmp9_ + 1;
				_tmp10_ = _actor_index;
				_tmp11_ = _actor_size;
				if (!(_tmp10_ < _tmp11_)) {
					break;
				}
				_tmp12_ = _actor_list;
				_tmp13_ = _actor_index;
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
				actor = (ClutterActor*) _tmp14_;
				_tmp15_ = actor;
				clutter_actor_set_reactive (_tmp15_, TRUE);
				_g_object_unref0 (actor);
			}
			_g_object_unref0 (_actor_list);
		}
	}
	_tmp16_ = self->priv->_dragging;
	if (_tmp16_) {
		ClutterActor* _tmp17_;
		ClutterActor* _tmp18_;
		ClutterStage* _tmp19_;
		guint _tmp20_;
		_tmp17_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
		_tmp18_ = _tmp17_;
		_tmp19_ = clutter_actor_get_stage (_tmp18_);
		g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp20_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
	}
	gala_drag_drop_action_set_dragging (self, FALSE);
	_g_object_unref0 (source_list);
}


GalaDragDropActionType
gala_drag_drop_action_get_drag_type (GalaDragDropAction* self)
{
	GalaDragDropActionType result;
	GalaDragDropActionType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_drag_type;
	result = _tmp0_;
	return result;
}


static void
gala_drag_drop_action_set_drag_type (GalaDragDropAction* self,
                                     GalaDragDropActionType value)
{
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_drag_type (self) != value) {
		self->priv->_drag_type = value;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY]);
	}
}


const gchar*
gala_drag_drop_action_get_drag_id (GalaDragDropAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_drag_id;
	result = _tmp0_;
	return result;
}


static void
gala_drag_drop_action_set_drag_id (GalaDragDropAction* self,
                                   const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gala_drag_drop_action_get_drag_id (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_drag_id);
		self->priv->_drag_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY]);
	}
}


ClutterActor*
gala_drag_drop_action_get_handle (GalaDragDropAction* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_handle;
	result = _tmp0_;
	return result;
}


static void
gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                  ClutterActor* value)
{
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_handle (self) != value) {
		ClutterActor* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_handle);
		self->priv->_handle = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY]);
	}
}


gboolean
gala_drag_drop_action_get_dragging (GalaDragDropAction* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_dragging;
	result = _tmp0_;
	return result;
}


static void
gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_dragging (self) != value) {
		self->priv->_dragging = value;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY]);
	}
}


gboolean
gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_allow_bubbling;
	result = _tmp0_;
	return result;
}


void
gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self,
                                          gboolean value)
{
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_allow_bubbling (self) != value) {
		self->priv->_allow_bubbling = value;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY]);
	}
}


static void
g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef gpointer (*GMarshalFunc_OBJECT__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_OBJECT__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_OBJECT__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
	g_value_take_object (return_value, v_return);
}


static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}


static void
gala_drag_drop_action_class_init (GalaDragDropActionClass * klass)
{
	gala_drag_drop_action_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GalaDragDropActionPrivate));
	((ClutterActorMetaClass *) klass)->set_actor = (void (*) (ClutterActorMeta *, ClutterActor*)) gala_drag_drop_action_real_set_actor;
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_drag_drop_action_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_drag_drop_action_set_property;
	G_OBJECT_CLASS (klass)->finalize = gala_drag_drop_action_finalize;
	/**
	 * The type of the action
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY] = g_param_spec_enum ("drag-type", "drag-type", "drag-type", GALA_TYPE_DRAG_DROP_ACTION_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The unique id given to this drag-drop-group
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY] = g_param_spec_string ("drag-id", "drag-id", "drag-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY] = g_param_spec_object ("handle", "handle", "handle", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Indicates whether a drag action is currently active
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY] = g_param_spec_boolean ("dragging", "dragging", "dragging", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Allow checking the parents of reactive children if they are valid destinations
	 * if the child is none
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY] = g_param_spec_boolean ("allow-bubbling", "allow-bubbling", "allow-bubbling", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * A drag has been started. You have to connect to this signal and
	 * return an actor that is transformed during the drag operation.
	 *
	 * @param x The global x coordinate where the action was activated
	 * @param y The global y coordinate where the action was activated
	 * @return  A ClutterActor that serves as handle
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL] = g_signal_new ("drag-begin", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT, clutter_actor_get_type (), 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
	/**
	 * A drag has been canceled. You may want to consider cleaning up
	 * your handle.
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL] = g_signal_new ("drag-canceled", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	 * A drag action has successfully been finished.
	 *
	 * @param actor The actor on which the drag finished
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL] = g_signal_new ("drag-end", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, clutter_actor_get_type ());
	/**
	 * The destination has been crossed
	 *
	 * @param hovered indicates whether the actor is now hovered or not
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL] = g_signal_new ("crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	/**
	 * Emitted on the source when a destination is crossed.
	 *
	 * @param destination The destination actor that has been crossed
	 * @param hovered     Whether the actor is now hovered or has just been left
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL] = g_signal_new ("destination-crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, clutter_actor_get_type (), G_TYPE_BOOLEAN);
	/**
	 * The source has been clicked, but the movement was not larger than
	 * the drag threshold. Useful if the source is also activable.
	 *
	 * @param button The button which was pressed
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL] = g_signal_new ("actor-clicked", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
}


static void
gala_drag_drop_action_instance_init (GalaDragDropAction * self)
{
	self->priv = GALA_DRAG_DROP_ACTION_GET_PRIVATE (self);
	self->priv->_dragging = FALSE;
	self->priv->_allow_bubbling = TRUE;
	self->priv->hovered = NULL;
	self->priv->clicked = FALSE;
}


static void
gala_drag_drop_action_finalize (GObject * obj)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
		_tmp3_ = _tmp2_;
		gala_drag_drop_action_release_actor (self, _tmp3_);
	}
	_g_free0 (self->priv->_drag_id);
	_g_object_unref0 (self->priv->_handle);
	_g_object_unref0 (self->priv->hovered);
	G_OBJECT_CLASS (gala_drag_drop_action_parent_class)->finalize (obj);
}


GType
gala_drag_drop_action_get_type (void)
{
	static volatile gsize gala_drag_drop_action_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaDragDropActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drag_drop_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDragDropAction), 0, (GInstanceInitFunc) gala_drag_drop_action_instance_init, NULL };
		GType gala_drag_drop_action_type_id;
		gala_drag_drop_action_type_id = g_type_register_static (clutter_action_get_type (), "GalaDragDropAction", &g_define_type_info, 0);
		g_once_init_leave (&gala_drag_drop_action_type_id__volatile, gala_drag_drop_action_type_id);
	}
	return gala_drag_drop_action_type_id__volatile;
}


static void
_vala_gala_drag_drop_action_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
	switch (property_id) {
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
		g_value_set_enum (value, gala_drag_drop_action_get_drag_type (self));
		break;
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
		g_value_set_string (value, gala_drag_drop_action_get_drag_id (self));
		break;
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
		g_value_set_object (value, gala_drag_drop_action_get_handle (self));
		break;
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
		g_value_set_boolean (value, gala_drag_drop_action_get_dragging (self));
		break;
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
		g_value_set_boolean (value, gala_drag_drop_action_get_allow_bubbling (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_gala_drag_drop_action_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
	switch (property_id) {
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
		gala_drag_drop_action_set_drag_type (self, g_value_get_enum (value));
		break;
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
		gala_drag_drop_action_set_drag_id (self, g_value_get_string (value));
		break;
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
		gala_drag_drop_action_set_handle (self, g_value_get_object (value));
		break;
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
		gala_drag_drop_action_set_dragging (self, g_value_get_boolean (value));
		break;
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
		gala_drag_drop_action_set_allow_bubbling (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



